commandMake				PROTO STDCALL :DWORD
commandRun				PROTO STDCALL :DWORD
commandOpenFolder		PROTO STDCALL :DWORD
ProcessButton			PROTO STDCALL :DWORD, :DWORD

.code

ProcessButton	proc uses ebx hWnd:DWORD, wID:DWORD
LOCAL	TempPoint:POINT
	invoke	SendMessage, hMainToolbar, TB_GETBUTTONSIZE, 0,0
	shr		eax, 16
	mov		ebx, eax	;ebx = height of a toolbar  button
	mov		eax, wID
	.IF		eax==TBID_MAIN
		mov		TempPoint.x,0
		mov		TempPoint.y,30
		invoke	ClientToScreen, hWnd, ADDR TempPoint
		invoke	ShowPopupMenu, hWnd, hMainMenu, TempPoint.x, TempPoint.y
	.ELSEIF eax==TBID_BUILD
		invoke	commandMake, hWnd
	.ELSEIF eax==TBID_RUN
		invoke	commandRun, hWnd
	.ELSEIF eax==TBID_SETBUILD
		mov		TempPoint.x,0
		add		ebx, 30
		mov		TempPoint.y, ebx
		invoke	ClientToScreen, hWnd, ADDR TempPoint
		invoke	ShowPopupMenu, hWnd, hBuildMenu, TempPoint.x, TempPoint.y
	.ELSEIF eax==TBID_FOLDER
		invoke	commandOpenFolder, hWnd
	.ENDIF
ret	
ProcessButton	endp

commandMake		proc	hWnd:DWORD
LOCAL CommandPath[300]:BYTE
LOCAL CommandBuffer[300]:BYTE
	invoke	GetProjectValue, ADDR SectionGeneral, ADDR KeyPath, ADDR CommandPath
	.IF		eax==0
		jmp		@beeperror 
	.ENDIF
	invoke	SetCurrentDirectory, ADDR CommandPath
	.IF		eax==0
		jmp		@beeperror
	.ENDIF
	invoke	GetProjectValue, pCurBuild, ADDR KeyMake, ADDR CommandBuffer
	.IF		eax==0
		jmp		@beeperror
	.ENDIF
		
	invoke	ShellExecute, hWnd, ADDR tOpOpen, ADDR CommandBuffer, NULL, ADDR CommandPath, SW_SHOW
	.IF		eax<=32
		jmp		@bigerror
	.ENDIF
ret
@beeperror:
	invoke	MessageBeep, MB_OK	
ret
@bigerror:
	invoke	MessageBeep, MB_ICONERROR
ret
commandMake		endp

commandRun		proc	hWnd:DWORD
LOCAL CommandPath[300]:BYTE
LOCAL CommandBuffer[300]:BYTE
	invoke	GetProjectValue, ADDR SectionGeneral, ADDR KeyPath, ADDR CommandPath
	.IF		eax==0
		jmp		@beeperror 
	.ENDIF
	invoke	SetCurrentDirectory, ADDR CommandPath
	.IF		eax==0
		jmp		@beeperror
	.ENDIF
	invoke	GetProjectValue, pCurBuild, ADDR KeyRun, ADDR CommandBuffer
	.IF		eax==0
		jmp		@beeperror
	.ENDIF
		
	invoke	ShellExecute, hWnd, ADDR tOpOpen, ADDR CommandBuffer, NULL, ADDR CommandPath, SW_SHOW
	.IF		eax<=32
		jmp		@bigerror
	.ENDIF
ret
@beeperror:
	invoke	MessageBeep, MB_OK	
ret
@bigerror:
	invoke	MessageBeep, MB_ICONERROR

ret
commandRun		endp

commandOpenFolder		proc	hWnd:DWORD
LOCAL	CommandBuffer[300]:BYTE
	invoke	GetProjectValue, ADDR SectionGeneral, ADDR KeyPath, ADDR CommandBuffer
	.IF		eax==0
		jmp		@beeperror 
	.ENDIF
	invoke	ShellExecute, hWnd, ADDR tOpOpen,  ADDR CommandBuffer,\
				NULL, NULL, SW_SHOW	
	.IF		eax<=32
		jmp		@bigerror
	.ENDIF
ret
@beeperror:
	invoke	MessageBeep, MB_OK	
ret
@bigerror:
	invoke	MessageBeep, MB_ICONERROR
ret
commandOpenFolder		endp
