;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; IDEBar v1.2 - data.asm
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; General data for IDEBar
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

.data?
;-------------------
; general handles
;----
hBackBrush		dd	?

;-------------------
; window handles
;-----
hRebar			dd		?
hMainToolbar	dd		?

;-------------------
; general structures
;-----
icex			INITCOMMONCONTROLSEX	<?>

.data
;-------------------
; Classnames
;-----
ClassStatic		db		"STATIC",0
RebarClass		db		"RebarWindow32",0

;--------------------
; Toolbar structure!
;-----
MainTBButtons	TBBUTTON <0, TBID_MAIN, TBSTATE_ENABLED ,TBSTYLE_BUTTON, 0, 0>
				TBBUTTON <6, TBID_SETBUILD, TBSTATE_ENABLED,TBSTYLE_BUTTON, 0,0>
				TBBUTTON <0, 0, TBSTATE_ENABLED,TBSTYLE_SEP, 0, 0>
				TBBUTTON <1, TBID_BUILD, TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
				TBBUTTON <2, TBID_RUN, TBSTATE_ENABLED,TBSTYLE_BUTTON,0, 0>
				TBBUTTON <0, 0, TBSTATE_ENABLED,TBSTYLE_SEP, 0, 0>
				TBBUTTON <3, TBID_FILES, TBSTATE_ENABLED,TBSTYLE_BUTTON, 0, 0>
				TBBUTTON <5, TBID_RESOURCES, TBSTATE_ENABLED,TBSTYLE_BUTTON, 0,0>
				TBBUTTON <4, TBID_FOLDER, TBSTATE_ENABLED,TBSTYLE_BUTTON, 0,0>
				

				
				
MAINTBBITMAPCOUNT	equ 7		; number of bitmaps in toolbar bitmap resource
MAINTBBUTTONCOUNT	equ 9		; number of buttons on the toolbar

;--------------------
; Menu item texts
;-----
textProjectMng		db		"Project Manager",0
textOpenINI			db		"Edit project file",0
textExit			db		"Quit",0
textNoCurProject	db		"[No current project]",0
textAbout			db		"About",0

textReleaseBuild	db		"Release build",0
textDebugBuild		db		"Debug build",0

;--------------------
; Error texts
;-----
ERRreg			db	"ERROR: Could not open or create the main registry keys.",0
ERRreg_com		db	"Error retrieving registry data.",0
ErrWrongName	db	"The name you've entered is not a valid project name. A name can consist "
				db	"of the characters a-z A-Z 0-9 .  - (space)",0
qtRemoveProject db	"Are you sure you want to remove this project?",0

;--------------------
; Registry keys
;-----
MainRegKey		db	"Software\Exagone\IDEBar\1.2",0
ProjectsKey		db	"projects",0
LastProjectKey	db	"LastProject",0

;--------------------
; General texts
;-----
IniFilter		db	"Project files (*.ini)", 0
				db	"*.ini",0
				db	"All files (*.*)",0
				db	"*.*",0,0
TitleText		db	"Select project file...",0
FormatNumber	db	"%lu",0
tOpOpen			db	"open",0
KeyDefault		db	"_!@_",0 
tAbout			db	"IDEBar v1.2 beta",0dh,0dh
				db	" 2001 by Exagone (Thomas Bleeker).",0dh, 0dh
				db	"This is a beta version, not all the functions are "
				db	"implemeted yet. ",0dh
				db	"IDEBar is freeware, you can distribute it freely as "
				db	"long as it's the full original package. The source "
				db 	"code is also available, you may modify it for personal use "
				db	"but you should leave this message and the original "
				db	"credits in the program. Suggestions are welcome:",0dh
				db	"mail: _thomas_@runbox.com, site: http://exagone.cjb.net", 0
				
				
;--------------------
; INI File texts
;-----

SectionGeneral		db	"general",0
SectionRelease		db	"release",0
SectionDebug		db	"debug",0
SectionFiles		db	"files",0
SectionResources	db	"resources",0
;Section

KeyPath				db	"basepath",0	;in [general]
KeyMake				db	"make",0		;in [release] or [debug]
KeyRun				db	"run",0			;in [release] or [debug]
KeyLastBuild		db	"lastbuild",0	;in [general]


hMainRegKey		dd	?
hProjectsKey	dd	?
KeyDisp			dd	?
LastProject		db	41 dup (?)
fCurProject		db	?
CurProjectINI	db	260 dup (?)
CurProject		db	41 dup (?)

pCurBuild		dd	?		;pointer to string with current release
dwCurBuild		dd	?		; BUILD_RELEASE or BUILD_DEBUG


hMainMenu		dd		?
hBuildMenu		dd		?
hProjectsMenu	dd		?



;--------------------
; End marking
;-----
.code
end start