CreateRebar		PROTO	STDCALL :DWORD
.code
;===============================================================================
;							Create main rebar control
;===============================================================================
CreateRebar	proc	uses ebx hWnd:DWORD
LOCAL rbi:REBARINFO
LOCAL rbBand:REBARBANDINFO

	IFNDEF	CCS_VERT
		CCS_VERT equ 80h
	ENDIF

	; --- Create rebar window ---
	invoke	CreateWindowEx, WS_EX_TOOLWINDOW, ADDR RebarClass,\
 				NULL, WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or\
 				WS_CLIPCHILDREN or CCS_VERT or CCS_NODIVIDER or CCS_NOPARENTALIGN or CCS_NOMOVEY,\
 				0,30,30,100, hWnd, NULL, hInstance, NULL
 	mov		hRebar, eax
 	
	

	mov		rbi.cbSize, SIZEOF REBARINFO
	mov		rbi.fMask, 0
	mov		rbi.himl, NULL
	invoke	SendMessage, hRebar, RB_SETBARINFO, 0, ADDR rbi


	; --- about bitmap ---
	invoke	CreateWindowEx, NULL, ADDR ClassStatic, NULL, SS_BITMAP +WS_CHILD+WS_VISIBLE\
			+SS_CENTERIMAGE,\
		0,0,26,30, hWnd, 320, hInstance, NULL
	mov ebx, eax
	invoke	LoadBitmap, hInstance, IDB_LOGO
	invoke	SendMessage, ebx, STM_SETIMAGE, IMAGE_BITMAP, eax

    	
    	
    	
    	
	; --- Create main toolbar ---
    invoke	LoadBitmap, hInstance, IDB_TOOLBAR
	mov		ecx, eax
	invoke	CreateToolbarEx, hWnd,\
				WS_CHILD or WS_VISIBLE or CCS_NODIVIDER or CCS_NOPARENTALIGN or CCS_NOMOVEY or TBSTYLE_FLAT or TBSTYLE_WRAPABLE or WS_CLIPSIBLINGS or  TBSTYLE_TOOLTIPS,\
				WID_TOOLBAR,MAINTBBITMAPCOUNT,0, ecx, ADDR MainTBButtons,\
				MAINTBBUTTONCOUNT,16,16,16,16,SIZEOF TBBUTTON
	mov		hMainToolbar, eax

				
				
	invoke	SendMessage, hMainToolbar, TB_AUTOSIZE, 0, 0
	; --- add new band ---

	mov		rbBand.cbSize, SIZEOF REBARBANDINFO
	mov		rbBand.fMask,  RBBIM_CHILD or RBBIM_CHILDSIZE or RBBIM_COLORS or\
						   RBBIM_ID or RBBIM_STYLE 
mov		rbBand.fStyle,  RBBS_NOGRIPPER
	mov		rbBand.clrBack, 0ff8000h
	mov		eax, hMainToolbar
	mov		rbBand.hwndChild, eax

	invoke	SendMessage, hMainToolbar, TB_GETBUTTONSIZE, 0,0
	and		eax, 0ffffh
	mov   	rbBand.cxMinChild, 200;eax
	mov   	rbBand.cyMinChild, eax
	invoke	SendMessage, hRebar, RB_INSERTBAND, -1, ADDR rbBand
	invoke	UpdateWindow, hMainToolbar
	invoke	UpdateWindow, hRebar
ret
CreateRebar	endp