.486
.model flat, stdcall
        
option casemap: none
include d:\masm32\include\windows.inc
include d:\masm32\include\user32.inc
include d:\masm32\include\comdlg32.inc
include d:\masm32\include\comctl32.inc
include d:\masm32\include\kernel32.inc
include d:\masm32\include\advapi32.inc
include d:\masm32\include\gdi32.inc
include d:\masm32\include\shell32.inc
includelib d:\masm32\lib\kernel32.lib
includelib d:\masm32\lib\user32.lib
includelib d:\masm32\lib\gdi32.lib
includelib d:\masm32\lib\shell32.lib
includelib d:\masm32\lib\comdlg32.lib
includelib d:\masm32\lib\comctl32.lib
includelib d:\masm32\lib\advapi32.lib
include		ALL.inc
include		resources.inc
WinMain PROTO STDCALL :DWORD, :DWORD, :DWORD, :DWORD

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; IDEBar v1.2 - Appbar.asm
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; General functions to create and manage the AppBar
; Most code directly converted from the appbar example in MSDN
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;-------------------------------------------------------------------------------
; PROTOTYPES
;-------------------------------------------------------------------------------
NewAppBar 				PROTO STDCALL	:DWORD, :DWORD
KillAppBar				PROTO STDCALL	:DWORD
SendAppBarWinPosChange 	PROTO STDCALL 	:DWORD
SendAppBarActive		PROTO STDCALL 	:DWORD
SuggestScreenRect		PROTO STDCALL 	:DWORD, :DWORD, :DWORD
SetAppBarPos			PROTO STDCALL 	:DWORD, :DWORD, :DWORD

WndProc PROTO STDCALL :DWORD, :DWORD, :DWORD, :DWORD

CreateRebar		PROTO	STDCALL :DWORD
CreateRegKeys			PROTO STDCALL
CloseRegKeys			PROTO STDCALL
BrowseProjectFile		PROTO STDCALL 	:DWORD, :DWORD
GetLastUsedProject		PROTO STDCALL
SetCurrentProject		PROTO STDCALL
SetLastProject			PROTO STDCALL
GetINIFromProjectName	PROTO STDCALL
DeleteProject			PROTO STDCALL :DWORD
CheckProjectName		PROTO STDCALL :DWORD
GetProjectValue			PROTO STDCALL :DWORD, :DWORD, :DWORD
GetProjectInt			PROTO STDCALL :DWORD, :DWORD
SetProjectInt			PROTO STDCALL :DWORD, :DWORD, :DWORD

InitPopupMenus			PROTO STDCALL :DWORD
DeletePopupMenus		PROTO STDCALL
ShowPopupMenu			PROTO STDCALL :DWORD, :DWORD, :DWORD, :DWORD
ProcessMenu				PROTO STDCALL :DWORD, :DWORD





;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; IDEBar v1.2 - Project manager.asm
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Code for the project manager dialog and new project dialog
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;===============================================================================
;	Prototypes
;===============================================================================
ShowProjectManager		PROTO	STDCALL :DWORD
PMDlgProc				PROTO	STDCALL :DWORD, :DWORD, :DWORD, :DWORD
PNDlgProc				PROTO	STDCALL :DWORD, :DWORD, :DWORD, :DWORD

commandMake				PROTO STDCALL :DWORD
commandRun				PROTO STDCALL :DWORD
commandOpenFolder		PROTO STDCALL :DWORD
ProcessButton			PROTO STDCALL :DWORD, :DWORD

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; IDEBar v1.2 - data.asm
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; General data for IDEBar
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

.const
.data?

hInstance	dd	?

;-------------------
; general handles
;----
hBackBrush		dd	?

;-------------------
; window handles
;-----
hRebar			dd		?
hMainToolbar	dd		?

;-------------------
; general structures
;-----
icex			INITCOMMONCONTROLSEX	<?>

.data
AppName			db  "IDEBar v1.2 beta",0
ClassName		db  "IDEBAR32",0

;-------------------
; Classnames
;-----
ClassStatic		db		"STATIC",0
RebarClass		db		"RebarWindow32",0

;--------------------
; Toolbar structure!
;-----
MainTBButtons	TBBUTTON <0, TBID_MAIN, TBSTATE_ENABLED ,TBSTYLE_BUTTON, 0, 0>
				TBBUTTON <6, TBID_SETBUILD, TBSTATE_ENABLED,TBSTYLE_BUTTON, 0,0>
				TBBUTTON <0, 0, TBSTATE_ENABLED,TBSTYLE_SEP, 0, 0>
				TBBUTTON <1, TBID_BUILD, TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
				TBBUTTON <2, TBID_RUN, TBSTATE_ENABLED,TBSTYLE_BUTTON,0, 0>
				TBBUTTON <0, 0, TBSTATE_ENABLED,TBSTYLE_SEP, 0, 0>
				TBBUTTON <3, TBID_FILES, TBSTATE_ENABLED,TBSTYLE_BUTTON, 0, 0>
				TBBUTTON <5, TBID_RESOURCES, TBSTATE_ENABLED,TBSTYLE_BUTTON, 0,0>
				TBBUTTON <4, TBID_FOLDER, TBSTATE_ENABLED,TBSTYLE_BUTTON, 0,0>
				

				
				
MAINTBBITMAPCOUNT	equ 7		; number of bitmaps in toolbar bitmap resource
MAINTBBUTTONCOUNT	equ 9		; number of buttons on the toolbar

;--------------------
; Menu item texts
;-----
textProjectMng		db		"Project Manager",0
textOpenINI			db		"Edit project file",0
textExit			db		"Quit",0
textNoCurProject	db		"[No current project]",0
textAbout			db		"About",0

textReleaseBuild	db		"Release build",0
textDebugBuild		db		"Debug build",0

;--------------------
; Error texts
;-----
ERRreg			db	"ERROR: Could not open or create the main registry keys.",0
ERRreg_com		db	"Error retrieving registry data.",0
ErrWrongName	db	"The name you've entered is not a valid project name. A name can consist "
				db	"of the characters a-z A-Z 0-9 .  - (space)",0
qtRemoveProject db	"Are you sure you want to remove this project?",0

;--------------------
; Registry keys
;-----
MainRegKey		db	"Software\Exagone\IDEBar\1.2",0
ProjectsKey		db	"projects",0
LastProjectKey	db	"LastProject",0

;--------------------
; General texts
;-----
IniFilter		db	"Project files (*.ini)", 0
				db	"*.ini",0
				db	"All files (*.*)",0
				db	"*.*",0,0
TitleText		db	"Select project file...",0
FormatNumber	db	"%lu",0
tOpOpen			db	"open",0
KeyDefault		db	"_!@_",0 
tAbout			db	"IDEBar v1.2 beta",0dh,0dh
				db	" 2001 by Exagone (Thomas Bleeker).",0dh, 0dh
				db	"This is a beta version, not all the functions are "
				db	"implemeted yet. ",0dh
				db	"IDEBar is freeware, you can distribute it freely as "
				db	"long as it's the full original package. The source "
				db 	"code is also available, you may modify it for personal use "
				db	"but you should leave this message and the original "
				db	"credits in the program. Suggestions are welcome:",0dh
				db	"mail: _thomas_@runbox.com, site: http://exagone.cjb.net", 0
				
				
;--------------------
; INI File texts
;-----

SectionGeneral		db	"general",0
SectionRelease		db	"release",0
SectionDebug		db	"debug",0
SectionFiles		db	"files",0
SectionResources	db	"resources",0
;Section

KeyPath				db	"basepath",0	;in [general]
KeyMake				db	"make",0		;in [release] or [debug]
KeyRun				db	"run",0			;in [release] or [debug]
KeyLastBuild		db	"lastbuild",0	;in [general]


hMainRegKey		dd	?
hProjectsKey	dd	?
KeyDisp			dd	?
LastProject		db	41 dup (?)
fCurProject		db	?
CurProjectINI	db	260 dup (?)
CurProject		db	41 dup (?)

pCurBuild		dd	?		;pointer to string with current release
dwCurBuild		dd	?		; BUILD_RELEASE or BUILD_DEBUG


hMainMenu		dd		?
hBuildMenu		dd		?
hProjectsMenu	dd		?



;--------------------
; End marking
;-----
.code
start:
	
	invoke	GetModuleHandle, NULL
	mov		hInstance, eax
	
	invoke	InitCommonControls
	
	mov		icex.dwSize, SIZEOF INITCOMMONCONTROLSEX
	mov		icex.dwICC, ICC_COOL_CLASSES or ICC_BAR_CLASSES
	invoke	InitCommonControlsEx, ADDR icex

@normal:
	invoke WinMain, hInstance, NULL, NULL,NULL
	invoke ExitProcess,NULL

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:DWORD
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	invoke	CreateSolidBrush, 00ff8000h
	mov		hBackBrush, eax
	mov   wc.hbrBackground,eax 
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon, eax
	mov   wc.hIconSm, eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc

	invoke CreateWindowEx, WS_EX_DLGMODALFRAME or WS_EX_TOOLWINDOW+WS_EX_TOPMOST,ADDR ClassName,ADDR AppName,\
           WS_POPUP,\
           0,0,100,100,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	invoke	DeleteObject, hBackBrush
	mov     eax,msg.wParam
	ret
WinMain endp







	

;-------------------------------------------------------------------------------
; NewAppBar
;-------------------------------------------------------------------------------
; Returns 0 on failure, 1 on success
;
NewAppBar	proc	hWnd:DWORD, CallBackMsg:DWORD
LOCAL	abd:APPBARDATA
	mov		abd.cbSize, SIZEOF APPBARDATA
	push	CallBackMsg
	pop		abd.uCallbackMessage
	push	hWnd
	pop		abd.hwnd
	invoke	SHAppBarMessage, ABM_NEW, ADDR abd
ret
NewAppBar	endp

;-------------------------------------------------------------------------------
; Kill AppBar
;-------------------------------------------------------------------------------
;always returns true (due to ABM_REMOVE)
KillAppBar	proc	hWnd:DWORD

LOCAL	abd:APPBARDATA
	mov		abd.cbSize, SIZEOF APPBARDATA
	push	hWnd
	pop		abd.hwnd
	invoke	SHAppBarMessage, ABM_REMOVE, ADDR abd
ret
KillAppBar	endp

;-------------------------------------------------------------------------------
; Suggest screen rect
;-------------------------------------------------------------------------------
; suggests a screen rect to the appbar
; always returns true (due to ABM_QUERYPOS)
SuggestScreenRect	proc	hWnd:DWORD, lpRC:DWORD, uEdge:DWORD
LOCAL	abd:APPBARDATA
	mov		abd.cbSize, SIZEOF APPBARDATA
	push	uEdge
	pop		abd.uEdge
	push	hWnd
	pop		abd.hwnd
	mov		ecx, lpRC
	mov		eax, [ecx]	
	mov		abd.rc.left, eax
	mov		eax, [ecx+4]	
	mov		abd.rc.top, eax
	mov		eax, [ecx+8]	
	mov		abd.rc.right, eax
	mov		eax, [ecx+12]	
	mov		abd.rc.bottom, eax
	invoke	SHAppBarMessage, ABM_QUERYPOS, ADDR abd
	mov		ecx, lpRC
	mov		eax, abd.rc.left
	mov		[ecx], eax
	mov		eax, abd.rc.top
	mov		[ecx+4], eax
	mov		eax, abd.rc.right
	mov		[ecx+8], eax
	mov		eax, abd.rc.bottom
	mov		[ecx+12], eax	
	xor		eax, eax ;restore result of ABM_QUERYPOS
	inc		eax
ret
SuggestScreenRect	endp
;-------------------------------------------------------------------------------
; SetAppBarPos
;-------------------------------------------------------------------------------
;always returns true due to ABM_SETPOS
SetAppBarPos		proc	hWnd:DWORD, lpRC:DWORD, uEdge:DWORD
LOCAL	abd:APPBARDATA
	mov		abd.cbSize, SIZEOF APPBARDATA
	push	uEdge
	pop		abd.uEdge
	push	hWnd
	pop		abd.hwnd
	mov		ecx, lpRC
	mov		eax, [ecx]	
	mov		abd.rc.left, eax
	mov		eax, [ecx+4]	
	mov		abd.rc.top, eax
	mov		eax, [ecx+8]	
	mov		abd.rc.right, eax
	mov		eax, [ecx+12]	
	mov		abd.rc.bottom, eax
	

	invoke	SHAppBarMessage, ABM_SETPOS, ADDR abd
	mov		ecx, lpRC
	mov		eax, abd.rc.left
	mov		[ecx], eax
	mov		eax, abd.rc.top
	mov		[ecx+4], eax
	mov		eax, abd.rc.right
	mov		[ecx+8], eax
	mov		eax, abd.rc.bottom
	mov		[ecx+12], eax	
	xor		eax, eax ;restore result of ABM_SETPOS
	inc		eax
ret
SetAppBarPos		endp

;-------------------------------------------------------------------------------
; SendAppBarActive
;-------------------------------------------------------------------------------
SendAppBarActive	proc	hWnd:DWORD
LOCAL	abd:APPBARDATA
	mov		abd.cbSize, SIZEOF APPBARDATA
	push	hWnd
	pop		abd.hwnd
	invoke	SHAppBarMessage, ABM_ACTIVATE, ADDR abd
ret
SendAppBarActive	endp

;-------------------------------------------------------------------------------
; Send AppBar window position change
;-------------------------------------------------------------------------------
SendAppBarWinPosChange	proc	hWnd:DWORD
LOCAL	abd:APPBARDATA
	mov		abd.cbSize, SIZEOF APPBARDATA
	push	hWnd
	pop		abd.hwnd
	invoke	SHAppBarMessage, ABM_WINDOWPOSCHANGED, ADDR abd
ret
SendAppBarWinPosChange	endp

;===============================================================================
; WndProc
;===============================================================================
WndProc proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL TempRect:RECT
LOCAL ProgRect:RECT
	mov eax, uMsg
;-------------------------------------------------------------------------------
; WM_CREATE
;-------------------------------------------------------------------------------
.IF eax==WM_CREATE
		
		; --- create main regkeys ---
		invoke	CreateRegKeys
		

    	; --- get last project ---
    	invoke	GetLastUsedProject
    	mov		fCurProject, al	;success flag
		; --- init main popup menu ---
		invoke	InitPopupMenus, hWnd
		
		.IF		fCurProject
    		invoke	lstrcpy, ADDR CurProject, ADDR LastProject
    		invoke	SetCurrentProject
    	.ENDIF
    	
		; --- set app bar ---
		invoke	NewAppBar, hWnd, WM_APPBARMSG

    	invoke	CreateRebar, hWnd
    	invoke	GetClientRect, hRebar, ADDR TempRect
    	
		; --- set app bar size ---
		mov		ProgRect.left, 		0
		invoke	GetSystemMetrics, SM_CXSCREEN
		;dec		eax
		mov		ProgRect.right, 	eax
		invoke	GetSystemMetrics, SM_CYSCREEN
		;dec		eax
		mov		ProgRect.bottom, 	eax
		mov		ProgRect.top, 		0
		invoke	SuggestScreenRect, hWnd, ADDR ProgRect, ABE_RIGHT
		invoke	GetSystemMetrics, SM_CXDLGFRAME 
		mov		ecx, eax
		shl		ecx, 1
		add		ecx, 2
		mov		eax, ProgRect.right
		sub		eax, TempRect.right
		add		eax, TempRect.left		
		sub		eax, ecx
		mov		ProgRect.left, eax
		invoke	SetAppBarPos, hWnd, ADDR ProgRect, ABE_RIGHT
    	mov		ecx, ProgRect.right
    	sub		ecx, ProgRect.left
    	mov		edx, ProgRect.bottom
    	sub		edx, ProgRect.top
    
    	invoke	MoveWindow, hWnd, ProgRect.left, ProgRect.top, ecx, edx, TRUE
    	


    		mov		ecx, TempRect.right
    		sub		ecx, TempRect.left
    		mov		eax, 30
   			sub		eax, ecx
    		shr		eax, 2
    	 	invoke	MoveWindow, hRebar, eax,30,ecx,300, 1
;-------------------------------------------------------------------------------
; WM_COMMAND
;-------------------------------------------------------------------------------
    .ELSEIF	eax==WM_COMMAND
    	mov		eax, wParam
    	shr		eax, 16
    	.IF		eax==NULL
    		mov		eax, wParam
    		and		eax, 0ffffh
    		invoke	ProcessMenu, hWnd, eax
    		mov		eax, wParam
    		and		eax, 0ffffh
	   		invoke	ProcessButton, hWnd, eax
    	.ENDIF
    	
;-------------------------------------------------------------------------------
; WM_APPBARMSG
;-------------------------------------------------------------------------------
    .ELSEIF eax==WM_APPBARMSG
    	mov		eax, wParam
    	.IF		eax==ABN_POSCHANGED
    		    	invoke	GetClientRect, hRebar, ADDR TempRect
    			mov		ProgRect.left, 		0
				invoke	GetSystemMetrics, SM_CXSCREEN
				;dec		eax
				mov		ProgRect.right, 	eax
				invoke	GetSystemMetrics, SM_CYSCREEN
				;dec		eax
				mov		ProgRect.bottom, 	eax
				mov		ProgRect.top, 		0
				invoke	SuggestScreenRect, hWnd, ADDR ProgRect, ABE_RIGHT
				invoke	GetSystemMetrics, SM_CXDLGFRAME 
				mov		ecx, eax
				shl		ecx, 1
					
				mov		eax, ProgRect.right
				sub		eax, TempRect.right
				add		eax, TempRect.left		
				sub		eax, ecx
				
				;size = 30 -  2x border - rebar size
				
				mov		ProgRect.left, eax
				invoke	SetAppBarPos, hWnd, ADDR ProgRect, ABE_RIGHT
		    	mov		ecx, ProgRect.right
		    	sub		ecx, ProgRect.left
		    	mov		edx, ProgRect.bottom
		    	sub		edx, ProgRect.top

		    	invoke	MoveWindow, hWnd, ProgRect.left, ProgRect.top, ecx, edx, TRUE
    	.ENDIF
    		mov		ecx, TempRect.right
    		sub		ecx, TempRect.left
    		mov		eax, 30
   			sub		eax, ecx
    		shr		eax, 2
    	 	invoke	MoveWindow, hRebar, eax,30,ecx,300, 1
	.ELSEIF eax==WM_DESTROY
		invoke	SetLastProject
		invoke	DeletePopupMenus
		invoke	CloseRegKeys
		invoke	KillAppBar, hWnd
		invoke 	PostQuitMessage,NULL
;-------------------------------------------------------------------------------
; WM_ACTIVATE
;-------------------------------------------------------------------------------
	.ELSEIF eax==WM_ACTIVATE
		invoke	SendAppBarActive, hWnd
;-------------------------------------------------------------------------------
; WM_WINDOWPOSCHANGED
;-------------------------------------------------------------------------------
	.ELSEIF eax==WM_WINDOWPOSCHANGED
		invoke	SendAppBarWinPosChange, hWnd
;-------------------------------------------------------------------------------
; Default window proc
;-------------------------------------------------------------------------------
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
@wp_end:
	ret
WndProc endp
;===============================================================================
;							Create main rebar control
;===============================================================================
CreateRebar	proc	uses ebx hWnd:DWORD
LOCAL rbi:REBARINFO
LOCAL rbBand:REBARBANDINFO

	IFNDEF	CCS_VERT
		CCS_VERT equ 80h
	ENDIF

	; --- Create rebar window ---
	invoke	CreateWindowEx, WS_EX_TOOLWINDOW, ADDR RebarClass,\
 				NULL, WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or\
 				WS_CLIPCHILDREN or CCS_VERT or CCS_NODIVIDER or CCS_NOPARENTALIGN or CCS_NOMOVEY,\
 				0,30,30,100, hWnd, NULL, hInstance, NULL
 	mov		hRebar, eax
 	
	

	mov		rbi.cbSize, SIZEOF REBARINFO
	mov		rbi.fMask, 0
	mov		rbi.himl, NULL
	invoke	SendMessage, hRebar, RB_SETBARINFO, 0, ADDR rbi


	; --- about bitmap ---
	invoke	CreateWindowEx, NULL, ADDR ClassStatic, NULL, SS_BITMAP +WS_CHILD+WS_VISIBLE\
			+SS_CENTERIMAGE,\
		0,0,26,30, hWnd, 320, hInstance, NULL
	mov ebx, eax
	invoke	LoadBitmap, hInstance, IDB_LOGO
	invoke	SendMessage, ebx, STM_SETIMAGE, IMAGE_BITMAP, eax

    	
    	
    	
    	
	; --- Create main toolbar ---
    invoke	LoadBitmap, hInstance, IDB_TOOLBAR
	mov		ecx, eax
	invoke	CreateToolbarEx, hWnd,\
				WS_CHILD or WS_VISIBLE or CCS_NODIVIDER or CCS_NOPARENTALIGN or CCS_NOMOVEY or TBSTYLE_FLAT or TBSTYLE_WRAPABLE or WS_CLIPSIBLINGS or  TBSTYLE_TOOLTIPS,\
				WID_TOOLBAR,MAINTBBITMAPCOUNT,0, ecx, ADDR MainTBButtons,\
				MAINTBBUTTONCOUNT,16,16,16,16,SIZEOF TBBUTTON
	mov		hMainToolbar, eax

				
				
	invoke	SendMessage, hMainToolbar, TB_AUTOSIZE, 0, 0
	; --- add new band ---

	mov		rbBand.cbSize, SIZEOF REBARBANDINFO
	mov		rbBand.fMask,  RBBIM_CHILD or RBBIM_CHILDSIZE or RBBIM_COLORS or\
						   RBBIM_ID or RBBIM_STYLE 
mov		rbBand.fStyle,  RBBS_NOGRIPPER
	mov		rbBand.clrBack, 0ff8000h
	mov		eax, hMainToolbar
	mov		rbBand.hwndChild, eax

	invoke	SendMessage, hMainToolbar, TB_GETBUTTONSIZE, 0,0
	and		eax, 0ffffh
	mov   	rbBand.cxMinChild, 200;eax
	mov   	rbBand.cyMinChild, eax
	invoke	SendMessage, hRebar, RB_INSERTBAND, -1, ADDR rbBand
	invoke	UpdateWindow, hMainToolbar
	invoke	UpdateWindow, hRebar
ret
CreateRebar	endp
CheckProjectName	proc	lpProjectName:DWORD
	mov		edx, lpProjectName
@textloop:
		mov		al, [edx]
		.IF		al==0
			jmp	@success
		.ELSEIF	al>="a" && al<="z" 
			jmp	@next
		.ELSEIF	al>="A" && al<="Z"
			jmp	@next
		.ELSEIF	al>="0" && al<="9"		
			jmp	@next
		.ELSEIF	al=="." || al=="-" || al==" "
			jmp	@next
		.ENDIF
		jmp		@failed
@next:
	inc		edx
	jmp		@textloop
@success:
xor		eax, eax
inc		eax
ret
@failed:
xor		eax, eax
ret
CheckProjectName	endp


DeleteProject	proc	lpProjectName:DWORD
	invoke	RegDeleteValue, hProjectsKey, lpProjectName
ret
DeleteProject	endp

GetINIFromProjectName	proc
LOCAL	PN_SIZE:DWORD
	mov			PN_SIZE, 259	
	invoke		RegQueryValueEx, hProjectsKey, ADDR CurProject, NULL,\
					NULL, ADDR CurProjectINI, ADDR PN_SIZE
ret
GetINIFromProjectName	endp


SetLastProject	proc
	invoke	lstrlen, ADDR CurProject
	inc		eax
	invoke	RegSetValueEx, hMainRegKey, ADDR LastProjectKey, NULL,\
				REG_SZ, ADDR CurProject, eax
	
	invoke	SetProjectInt, ADDR SectionGeneral, ADDR KeyLastBuild, dwCurBuild
ret
SetLastProject	endp


SetCurrentProject	proc
LOCAL	TempItem:MENUITEMINFO
	mov		TempItem.cbSize, SIZEOF TempItem
	mov		TempItem.fMask, MIIM_TYPE 
	mov		TempItem.fType, MFT_STRING		
	mov		TempItem.dwTypeData, offset CurProject
	invoke	SetMenuItemInfo, hMainMenu, IDM_CURPROJECT, FALSE, ADDR TempItem
	invoke	GetProjectInt, ADDR SectionGeneral, ADDR KeyLastBuild
	.IF		eax==BUILD_DEBUG
		mov		dwCurBuild, eax
		mov		pCurBuild, offset SectionDebug
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_DEBUG, MF_BYCOMMAND or MF_CHECKED
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_RELEASE, MF_BYCOMMAND or MF_UNCHECKED
	.ELSE
		mov		dwCurBuild, BUILD_RELEASE
		mov		pCurBuild, offset SectionRelease
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_DEBUG, MF_BYCOMMAND or MF_UNCHECKED
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_RELEASE, MF_BYCOMMAND or MF_CHECKED
	.ENDIF
ret
SetCurrentProject	endp


GetLastUsedProject	proc	uses ebx 
LOCAL	ProjectName[41]:BYTE
LOCAL	PN_SIZE:DWORD
LOCAL	PF_SIZE:DWORD
	mov			PN_SIZE, 41
	invoke		RegQueryValueEx, hMainRegKey, ADDR LastProjectKey, NULL,\
					NULL, ADDR LastProject, ADDR PN_SIZE
	xor		ebx, ebx
	.WHILE	TRUE
		mov		PN_SIZE, 41
		mov	PF_SIZE, 260
		invoke	RegEnumValue, hProjectsKey, ebx, ADDR ProjectName, ADDR PN_SIZE,\
					NULL, NULL,ADDR CurProjectINI, ADDR PF_SIZE
		.IF		eax==ERROR_NO_MORE_ITEMS
			.BREAK
		.ENDIF
		invoke	lstrcmp, ADDR ProjectName, ADDR LastProject
		.IF		eax==0
			inc		eax
			ret
		.ENDIF
		inc	ebx
	.ENDW
xor		eax, eax
ret
GetLastUsedProject	endp



BrowseProjectFile proc	hWnd:DWORD, lpBuffer:DWORD
LOCAL 	OFN:OPENFILENAME
	mov		OFN.lStructSize, SIZEOF OPENFILENAME
	push	hWnd
	pop		OFN.hWndOwner
	push	hInstance
	pop		OFN.hInstance
	mov		OFN.lpstrFilter, offset IniFilter
	mov		OFN.lpstrCustomFilter, NULL
	mov		OFN.nFilterIndex, 0
	mov		eax, lpBuffer
	mov		byte ptr [eax],0
	mov		OFN.lpstrFile, eax
	mov		OFN.nMaxFile, 300
	mov		OFN.lpstrFileTitle, offset TitleText
	mov		OFN.lpstrInitialDir, NULL
	mov		OFN.lpstrTitle, NULL
	mov		OFN.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST
	mov		OFN.lpstrDefExt, NULL
	invoke	GetOpenFileName, ADDR OFN
	
ret
BrowseProjectFile endp

CreateRegKeys	proc

	invoke	RegOpenKeyEx, HKEY_CURRENT_USER, ADDR MainRegKey, \
			NULL,  KEY_READ	or KEY_WRITE		, ADDR hMainRegKey
	.IF		eax!=ERROR_SUCCESS
		invoke	RegCreateKeyEx, HKEY_CURRENT_USER, ADDR MainRegKey, \
				NULL, NULL, NULL,   KEY_READ	or KEY_WRITE	, NULL, ADDR hMainRegKey, ADDR KeyDisp
	.ENDIF
	.IF		eax!=ERROR_SUCCESS
		jmp crr_failed
	.ENDIF

	invoke	RegOpenKeyEx, hMainRegKey, ADDR ProjectsKey,\
			NULL,   KEY_READ	or KEY_WRITE, ADDR hProjectsKey
	.IF		eax!=ERROR_SUCCESS
		invoke	RegCreateKeyEx, hMainRegKey, ADDR ProjectsKey, \
				NULL, NULL, NULL,   KEY_READ	or KEY_WRITE, NULL, ADDR hProjectsKey, ADDR KeyDisp
	.ENDIF
	.IF		eax!=ERROR_SUCCESS
		jmp crr_failed
	.ENDIF
	
	jmp		crr_success
crr_failed:

	invoke	MessageBox, NULL, ADDR ERRreg, ADDR AppName, MB_OK or MB_ICONERROR
	invoke	ExitProcess, 1
crr_success:

ret
CreateRegKeys	endp


CloseRegKeys	proc
	invoke	RegCloseKey, hProjectsKey
	invoke	RegCloseKey, hMainRegKey
ret
CloseRegKeys	endp


		
GetProjectInt	proc	lpSection:DWORD, lpKey:DWORD
		invoke	GetPrivateProfileInt, lpSection, lpKey, -1,ADDR CurProjectINI
ret
GetProjectInt	endp
				
GetProjectValue	proc	lpSection:DWORD, lpKey:DWORD, lpBuffer:DWORD
		invoke	GetPrivateProfileString,lpSection, lpKey,\
					ADDR KeyDefault, lpBuffer, 299,\
					ADDR CurProjectINI 
		mov		ecx, lpBuffer
		.IF		(eax==4 && dword ptr [ecx]=="_@!_")
			xor		eax, eax
			ret
		.ENDIF
ret
GetProjectValue endp

SetProjectInt	proc	lpSection:DWORD, lpKey:DWORD, value:DWORD
LOCAL	Buffer[16]:BYTE
	invoke	wsprintf, ADDR Buffer, ADDR FormatNumber, value
	invoke	WritePrivateProfileString, lpSection, lpKey, ADDR Buffer, ADDR CurProjectINI
ret
SetProjectInt	endp

 

InitPopupMenus		proc	hWnd:DWORD

	;---------------------------------------------
	; Main popup menu
	;------------
	invoke		CreatePopupMenu
	mov			hMainMenu, eax
	; current project name menu item:
	invoke		InsertMenu, hMainMenu, 0, MF_BYPOSITION or MF_STRING or MF_DISABLED\
					, IDM_CURPROJECT, ADDR textNoCurProject
	;seperator 1
	invoke		InsertMenu, hMainMenu, 1, MF_BYPOSITION or MF_SEPARATOR	\
					, NULL, NULL
	; "Project manager" menu item:
	invoke		InsertMenu, hMainMenu, 2, MF_BYPOSITION	 or MF_STRING or MF_ENABLED\
					, IDM_PROJECTMANAGER, ADDR textProjectMng
					
					
	; "Edit project file" menu item:
	invoke		InsertMenu, hMainMenu, 3, MF_BYPOSITION	 or MF_STRING or MF_ENABLED\
					, IDM_EDITPROJECTFILE, ADDR textOpenINI

	;seperator 2
	invoke		InsertMenu, hMainMenu, 4, MF_BYPOSITION or MF_SEPARATOR	\
					, NULL, NULL
	; "About" menu item:
	invoke		InsertMenu, hMainMenu, 5, MF_BYPOSITION	 or MF_STRING or MF_ENABLED\
					, IDM_ABOUT, ADDR textAbout	

	; "Exit" menu item:
	invoke		InsertMenu, hMainMenu, 6, MF_BYPOSITION	 or MF_STRING or MF_ENABLED\
					, IDM_EXIT, ADDR textExit	
	
	;---------------------------------------------
	; Select build popup menu
	;------------
	
	invoke		CreatePopupMenu
	mov			hBuildMenu, eax

	; release build menu item:
	invoke		InsertMenu, hBuildMenu, 0,MF_BYPOSITION or MF_STRING or MF_ENABLED,\
					IDM_BUILD_RELEASE, ADDR textReleaseBuild
	; debug build menu item:
	invoke		InsertMenu, hBuildMenu, 1,MF_BYPOSITION or MF_STRING or MF_ENABLED,\
					IDM_BUILD_DEBUG, ADDR textDebugBuild
					
					
ret
InitPopupMenus		endp



DeletePopupMenus		proc		
	invoke		DestroyMenu, hMainMenu
ret
DeletePopupMenus		endp


ShowPopupMenu		proc		hWnd:DWORD,hMenu:DWORD, xPos:DWORD, yPos:DWORD
	;Show a popup menu at xPos, yPos. hWnd receives the WM_COMMAND message if
	;a menu item is clickede
	invoke		TrackPopupMenu, hMenu,TPM_LEFTALIGN	or TPM_LEFTBUTTON,\
				 xPos, yPos, NULL, hWnd, NULL
ret
ShowPopupMenu		endp

ProcessMenu	proc hWnd:DWORD, wID:DWORD
	mov		eax, wID
	.IF		eax==IDM_EXIT
		invoke	SendMessage, hWnd, WM_CLOSE, NULL, NULL
	.ELSEIF	eax==IDM_PROJECTMANAGER
		invoke	ShowProjectManager, hWnd
	.ELSEIF eax==IDM_BUILD_RELEASE
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_RELEASE, MF_BYCOMMAND or MF_CHECKED
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_DEBUG, MF_BYCOMMAND or MF_UNCHECKED
		mov		dwCurBuild, BUILD_RELEASE
		mov		pCurBuild, offset SectionRelease
	.ELSEIF eax==IDM_BUILD_DEBUG
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_RELEASE, MF_BYCOMMAND or MF_UNCHECKED
		invoke	CheckMenuItem, hBuildMenu,IDM_BUILD_DEBUG, MF_BYCOMMAND or MF_CHECKED
		mov		dwCurBuild, BUILD_DEBUG
		mov		pCurBuild, offset SectionDebug
	.ELSEIF eax==IDM_EDITPROJECTFILE
		invoke	ShellExecute, hWnd, ADDR tOpOpen, ADDR CurProjectINI, NULL, NULL, SW_SHOW
		.IF		eax<=32
			MSGBOX "Error: could not open project file"
		.ENDIF
	.ELSEIF eax==IDM_ABOUT
		invoke	MessageBox, NULL, ADDR tAbout, ADDR AppName, MB_ICONINFORMATION
	.ENDIF
ret
ProcessMenu	endp









;===============================================================================
;	Show project manager
;===============================================================================
ShowProjectManager	proc	hWnd:DWORD
	invoke	DialogBoxParam, hInstance, IDD_PROJECTMANAGER, hWnd, ADDR PMDlgProc, NULL
	invoke	SetCurrentProject
ret
ShowProjectManager	endp

;===============================================================================
;	Project manager dialog proc
;===============================================================================	
PMDlgProc	proc	uses ebx hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL	ProjectName[41]:BYTE
LOCAL	TempProject[41]:BYTE
LOCAL	ProjectFile[260]:BYTE
LOCAL	TempINI[260]:BYTE
LOCAL	PN_SIZE:DWORD
LOCAL	PF_SIZE:DWORD
	mov		eax, uMsg
	.IF		eax==WM_INITDIALOG
		invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS, LB_RESETCONTENT, 0, 0
		mov			PN_SIZE, 41
		invoke		RegQueryValueEx, hMainRegKey, ADDR LastProjectKey, NULL,\
						NULL, ADDR LastProject, ADDR PN_SIZE
		xor		ebx, ebx
		.WHILE	TRUE
			mov		PN_SIZE, 41
			;mov	PF_SIZE, 260
			invoke	RegEnumValue, hProjectsKey, ebx, ADDR ProjectName, ADDR PN_SIZE,\
						NULL, NULL,NULL,NULL ;ADDR ProjectFile, ADDR PF_SIZE
			.IF		eax==ERROR_NO_MORE_ITEMS
				.BREAK
			.ENDIF
			invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS, LB_ADDSTRING, NULL, ADDR ProjectName
			push	eax
			invoke	lstrcmp, ADDR ProjectName, ADDR LastProject
			.IF		eax==0
				pop		eax
				invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS, LB_SETCURSEL, eax, NULL
			.ELSE
				pop		eax
			.ENDIF
			inc	ebx
		.ENDW
	.ELSEIF	eax==WM_COMMAND
		mov		eax, wParam
		shr		eax, 16
		.IF		eax==BN_CLICKED
			mov		eax, wParam
			.IF		ax==IDC_SELECT
				invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS, LB_GETCURSEL, 0, 0
				.IF		eax!=LB_ERR
					invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS,\
						 LB_GETTEXT, eax, ADDR CurProject
					invoke	GetINIFromProjectName
					invoke	SetLastProject
				.ENDIF
				invoke	EndDialog, hWnd, NULL
			.ELSEIF	ax==IDC_REMOVE
				invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS, LB_GETCURSEL, 0, 0
				mov		ebx, eax
				.IF		eax==LB_ERR
					invoke	MessageBeep, NULL
				.ELSE
					invoke	MessageBox, NULL, ADDR qtRemoveProject, ADDR AppName,\
								 MB_ICONQUESTION + MB_YESNO
					.IF		eax==IDYES
						invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS,\
						 LB_GETTEXT, ebx, ADDR TempProject
						invoke	SendDlgItemMessage, hWnd, IDC_PROJECTS,\
						 LB_DELETESTRING, ebx, 0
						invoke	DeleteProject, ADDR TempProject
					.ENDIF
				.ENDIF
			.ELSEIF	ax==IDC_ADD
				invoke	DialogBoxParam, hInstance, IDD_NEWPROJECT, hWnd, ADDR PNDlgProc, 0
			.ENDIF
		.ENDIF
	
	.ELSEIF		eax==WM_DESTROY
		invoke	EndDialog, hWnd, NULL
	.ELSEIF	eax==WM_CLOSE
		invoke	EndDialog, hWnd, NULL
	.ENDIF
xor eax,eax
ret
PMDlgProc	endp


PNDlgProc	proc	hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL	TempProject[41]:BYTE
LOCAL	TempINI[260]:BYTE
	mov		eax, uMsg
	.IF		eax==WM_INITDIALOG
		invoke	SendDlgItemMessage, hWnd, IDC_PROJECTNAME, EM_SETLIMITTEXT, 40, 0
	.ELSEIF	eax==WM_COMMAND
		mov		eax, wParam
		shr		eax, 16
		.IF		eax==BN_CLICKED
			mov		eax, wParam
			.IF		ax==IDCANCEL
				invoke	EndDialog, hWnd, NULL
			.ELSEIF	ax==IDOK
				invoke	GetDlgItemText, hWnd, IDC_PROJECTNAME, ADDR TempProject, 40
				invoke	CheckProjectName, ADDR TempProject
				.IF		eax==0
					invoke	MessageBox, NULL, ADDR ErrWrongName, ADDR AppName, MB_ICONERROR
				.ELSE
				; --- check if project name already exists
				invoke	RegQueryValueEx, hProjectsKey, ADDR TempProject, NULL, NULL, NULL, NULL
				.IF		eax==ERROR_SUCCESS
					MSGBOX "This project name already exists, please choose another one."
				ret
				.ENDIF
				invoke	BrowseProjectFile, hWnd, ADDR TempINI
				.IF		eax==TRUE
					invoke	lstrlen, ADDR TempINI
					inc		eax
					invoke	RegSetValueEx, hProjectsKey, ADDR TempProject, NULL,\
					REG_SZ, ADDR TempINI, eax
					invoke	GetParent, hWnd
					invoke	SendMessage, eax, WM_INITDIALOG, 0,0
					invoke	lstrcpy, ADDR CurProject, ADDR TempProject
					invoke	SetCurrentProject
					invoke	SetLastProject
				.ENDIF
		
					
					invoke	EndDialog, hWnd, 1
				.ENDIF
			.ENDIF
		.ENDIF
	.ELSEIF		eax==WM_DESTROY
		invoke	EndDialog, hWnd, NULL
	.ELSEIF	eax==WM_CLOSE
		invoke	EndDialog, hWnd, NULL
	.ENDIF
xor eax,eax
ret
PNDlgProc	endp


ProcessButton	proc uses ebx hWnd:DWORD, wID:DWORD
LOCAL	TempPoint:POINT
	invoke	SendMessage, hMainToolbar, TB_GETBUTTONSIZE, 0,0
	shr		eax, 16
	mov		ebx, eax	;ebx = height of a toolbar  button
	mov		eax, wID
	.IF		eax==TBID_MAIN
		mov		TempPoint.x,0
		mov		TempPoint.y,30
		invoke	ClientToScreen, hWnd, ADDR TempPoint
		invoke	ShowPopupMenu, hWnd, hMainMenu, TempPoint.x, TempPoint.y
	.ELSEIF eax==TBID_BUILD
		invoke	commandMake, hWnd
	.ELSEIF eax==TBID_RUN
		invoke	commandRun, hWnd
	.ELSEIF eax==TBID_SETBUILD
		mov		TempPoint.x,0
		add		ebx, 30
		mov		TempPoint.y, ebx
		invoke	ClientToScreen, hWnd, ADDR TempPoint
		invoke	ShowPopupMenu, hWnd, hBuildMenu, TempPoint.x, TempPoint.y
	.ELSEIF eax==TBID_FOLDER
		invoke	commandOpenFolder, hWnd
	.ENDIF
ret	
ProcessButton	endp

commandMake		proc	hWnd:DWORD
LOCAL CommandPath[300]:BYTE
LOCAL CommandBuffer[300]:BYTE
	invoke	GetProjectValue, ADDR SectionGeneral, ADDR KeyPath, ADDR CommandPath
	.IF		eax==0
		jmp		@beeperror 
	.ENDIF
	invoke	SetCurrentDirectory, ADDR CommandPath
	.IF		eax==0
		jmp		@beeperror
	.ENDIF
	invoke	GetProjectValue, pCurBuild, ADDR KeyMake, ADDR CommandBuffer
	.IF		eax==0
		jmp		@beeperror
	.ENDIF
		
	invoke	ShellExecute, hWnd, ADDR tOpOpen, ADDR CommandBuffer, NULL, ADDR CommandPath, SW_SHOW
	.IF		eax<=32
		jmp		@bigerror
	.ENDIF
ret
@beeperror:
	invoke	MessageBeep, MB_OK	
ret
@bigerror:
	invoke	MessageBeep, MB_ICONERROR
ret
commandMake		endp

commandRun		proc	hWnd:DWORD
LOCAL CommandPath[300]:BYTE
LOCAL CommandBuffer[300]:BYTE
	invoke	GetProjectValue, ADDR SectionGeneral, ADDR KeyPath, ADDR CommandPath
	.IF		eax==0
		jmp		@beeperror 
	.ENDIF
	invoke	SetCurrentDirectory, ADDR CommandPath
	.IF		eax==0
		jmp		@beeperror
	.ENDIF
	invoke	GetProjectValue, pCurBuild, ADDR KeyRun, ADDR CommandBuffer
	.IF		eax==0
		jmp		@beeperror
	.ENDIF
		
	invoke	ShellExecute, hWnd, ADDR tOpOpen, ADDR CommandBuffer, NULL, ADDR CommandPath, SW_SHOW
	.IF		eax<=32
		jmp		@bigerror
	.ENDIF
ret
@beeperror:
	invoke	MessageBeep, MB_OK	
ret
@bigerror:
	invoke	MessageBeep, MB_ICONERROR

ret
commandRun		endp

commandOpenFolder		proc	hWnd:DWORD
LOCAL	CommandBuffer[300]:BYTE
	invoke	GetProjectValue, ADDR SectionGeneral, ADDR KeyPath, ADDR CommandBuffer
	.IF		eax==0
		jmp		@beeperror 
	.ENDIF
	invoke	ShellExecute, hWnd, ADDR tOpOpen,  ADDR CommandBuffer,\
				NULL, NULL, SW_SHOW	
	.IF		eax<=32
		jmp		@bigerror
	.ENDIF
ret
@beeperror:
	invoke	MessageBeep, MB_OK	
ret
@bigerror:
	invoke	MessageBeep, MB_ICONERROR
ret
commandOpenFolder		endp
end start
